#ifndef _ARM_MAGIC_H
#define _ARM_MAGIC_H

#define ARM_POINTER_SIZE 4	// of analyzed system
#define ARM_INTEGER_SIZE 4	// of analyzed system

// MAGIC section...

// Virtual Page Table (or PaGe Directory (PGD))

// Where to start looking for VPT
#define ARM_VPT_MAGIC_ADDR 0x00000000

// Size of block with VPT (16 KB)
#define ARM_VPT_MAGIC_BS 16384		

// How many page to check, when looking for VPT
#define ARM_VPT_MAGIC_COUNT 50000

// At least how many valid entries require
#define ARM_VPT_MIN_REC 1

// How many entries can be invalid.
// This is max. value, when reached, 
// search is immediately terminated.
#define ARM_VPT_MAGIC_ERR_FATAL 17

// (#records / #errors) must be at least
#define ARM_VPT_MAGIC_ERR_RATIO 3

#endif
