
#include "globals.h"

// Debug function
int debug(){
	int i;

	printf("--------- Begin of debug info ---------\n");
	// size of block in analyzed image
	printf("guest_block_size: %d\n",img1.guest_block_size);

	// hw architecture of analyzed image
 	printf("architecture: %s\n",img1.architecture);

	// operation system if analyzed image
 	printf("operating_system: %s\n",img1.operating_system);

	// position of VPT (from beginning of file)
 	printf("VPT_address: 0x%"PRIx64"\n",img1.VPT_address);

	// size of image in kilobytes
 	printf("ram_size: %"PRIu64"\n",img1.ram_size);

	// distance between comm and headlist 
 	printf("ts_hl_comm_dst: %d\n",img1.ts_hl_comm_dst);

 	printf("md_hl_name_dst: %d\n",img1.md_hl_name_dst);

	// address of tasks list_head of one of taks_struct structures
 	printf("ts_one_of_lists: 0x%"PRIx64"\n",img1.ts_one_of_lists);

	// =TS_MAGIC_HL_MM_DST; // Distance from "tasks" list_head to "mm" mmstruct
 	printf("ts_hl_mm_dst: %d\n",img1.ts_hl_mm_dst);

	// =MM_MAGIC_PGD_DST;  //Distance from beginning of mm_struct to pgd variable
 	printf("mm_pgd_dst: %d\n",img1.mm_pgd_dst); 

	//list_heads around task_struct
	printf("ts_headlists_nuber:%d\n",img1.ts_headlists_number); 
	for (i=TS_MAGIC_HEADLIST_MAX;i>=0;i--){
		printf("  Headlist number %d: 0x%"PRIx64"\n",i,img1.ts_headlists[i]);
	}
	
	//list_heads around module
	printf("md_headlists_nuber:%d\n",img1.md_headlists_number); 
	for (i=MD_MAGIC_HEADLIST_MAX;i>=0;i--){
		printf("  Headlist number %d: 0x%"PRIx64"\n",i,img1.md_headlists[i]);
	}
	printf("--------- End of debug info ---------\n");

	return 0;
}


