/// Contains macro for debug output.
/**
 * @file
 */

#ifndef _DEBUG_H
#define _DEBUG_H

#include "globals.h"

// If not defined, debug is disabled completely
#define DEBUG

// dbg is global variable controling dbgprint
// compiler should optimize this  ( if (0) {..} )
#define debugon dbg=1
#define debugoff dbg=0


#ifdef DEBUG 
/// Macro for debug print
#define dbgprint(format, args...) \
	do {            \
		if (dbg){printf("[%s %d]: "format"\n", __FUNCTION__, __LINE__, ## args);}\
	} while ( 0 )
#else
#define dbgprint(format, args...) do {} while( 0 );
#endif

/*
 * Debug function
 *
 * Print lot of debug information when invoked
 */

int debug();

#endif
