#!/bin/bash
# 2010 niekt0@hysteria.sk 
# Under GNU/GPL

# This is just simple script for finding occurrences of 
# "interesting" strings in memory dump.
# Take it as example, or modify to satisfy your needs

#XXX change utility paths
bgrep=./bgrep
agrep=tre-agrep

if [ -z "$1" ]; then
	echo "Usage: $0 dump_file [options to bgrep]";
	echo "Example: $0 freebsd_256M_i386.dd"
	echo "Edit pattern list inside this script if needed."
	exit;
fi

if [ ! -f "$1" ]; then
	echo "Dump file does not exists."
	exit;
fi

# pattern definitions.
# add your own patterns here

# ssh keys:

# OpenSSH 
p_openssh="SA PRIVATE KEY-----";

# RFC 4716 SSH Public Key File Format (ssh2) 
p_ssh2="---- BEGIN SSH";

# Putty format 
p_putty="PuTTY-User-Key-File";

# OTR (Off-The-Record) keys 
p_otr="(private-key";


# /etc/shadow:

# Linux 
p_lshadow="root:\$1\$";

# Openbsd 
p_oshadow="root:\$2a\$";

# Commercial unix systems 
p_cshadow="root:[:alnum]{13}:"

# various passwords:

# subversion 
p_svn="password.V";

# Pidgin, PSI  (many programs using xml configuration files)
p_xml="<password>";

# MSSQL (and others) 
p_mssql1="password =";
p_mssql2="pass =";

# Viminfo 
p_vim="This viminfo file was";

# -----
# UTF-16 patterns:

# Firefox (linux)
p16_firefox="Password Manager";

# Skype (linux)
p16_skype="People Online";


#put it together:

pattern=( "$p_openssh" "$p_ssh2" "$p_putty" "$p_otr" "$p_lshadow" \
	"$p_oshadow" "$p_cshadow" "$p_svn" "$p_xml" "$p_mssql1" \
	"$p_mssql2" "$p_vim" )

pattern_utf16=( "$p16_firefox" "$p16_skype" )


# Lame solution:

echo "Using ${#pattern[@]} patterns."

grep_pattern=`for (( i=0;i<${#pattern[@]};i=i+1)); do echo -n "${pattern[$i]}|"; done`;

# escape "()" and remove last pipe 
grep_pattern=`echo "${grep_pattern}" | sed 's/(/\\\(/g;s/)/\\\)/g;s/|$//'`;

echo "grep pattern:";
echo "$grep_pattern";

echo "";
echo "Searching patterns...";
echo "";
strings -t x "$1" | grep -E "$grep_pattern" >  /tmp/pwdfind1.$$ 
cat /tmp/pwdfind1.$$

echo "";
echo "Searching UTF-16 patterns...";
echo "";
strings -e l -t x "$1" | grep -E "$grep_pattern" >  /tmp/pwdfind2.$$ 
cat /tmp/pwdfind2.$$


# I did not find this functionality usefull,
# but you may find it usefull

# print 50 chars before and 450 after pattern
#offset_before=50;
#length=500;


# print hexdumps for all occurences
#cat /tmp_pwdfind1.$$ | cut -d ' ' -f 1 | while read i; do echo "=====$i====="; i=$((0x$i - $offset_before)) && printf "%llx:\n" "$i" && xxd -l "$length" -s "$i" "$1"; done


